// ---------- Attention: Generated code, please do not modify! -----------

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIToasts;
import org.apache.myfaces.tobago.layout.Placement;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import javax.annotation.Generated;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/**
 Render toasts elements.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.ToastsTagDeclaration}.
 */
@Generated("component.stg")
public class UIToasts
    extends AbstractUIToasts  {

  private static final Tags TAG = Tags.toasts;

  public static final String COMPONENT_TYPE = TAG.componentType();

  public static final String COMPONENT_FAMILY = "javax.faces.Data";

  private static final Collection<String> EVENT_NAMES = Arrays.asList("reload");

  @Override
  public Collection<String> getEventNames() {
    return EVENT_NAMES;
  }

  @Override
  public String getDefaultEventName() {
    return "reload";
  }


  enum PropertyKeys {
    disposeDelay,
    markup,
    customClass,
    placement,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  /**
  Delay in milliseconds before hiding the toast. Default is "5000".
   Set to "-1" to never automatically hide the toast.
  <br>Default: <code>5000</code>
  */
  public java.lang.Integer getDisposeDelay() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.disposeDelay);
    if (value != null) {
      return value.intValue();
    }
    return 5000;
  }

  public void setDisposeDelay(java.lang.Integer disposeDelay) {
    getStateHelper().put(PropertyKeys.disposeDelay, disposeDelay);
  }

  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the &lt;tc:style&gt; tag. Example:

   <pre>
   &lt;tc:in&gt;
     &lt;tc:style customClass="my-emphasized"/&gt;
   &lt;/tc:in&gt;
   </pre>

   One capability is, to used external CSS libs.
   <br>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  /**
  Defines the placement of the toasts. Default is "bottomRight".
  <br>Default: <code>bottomRight</code><br>Allowed Values: <code>topLeft,topCenter,topRight,middleLeft,middleCenter,middleRight,bottomLeft,bottomCenter,bottomRight</code>
  */
  public org.apache.myfaces.tobago.layout.Placement getPlacement() {
    org.apache.myfaces.tobago.layout.Placement placement = (org.apache.myfaces.tobago.layout.Placement) getStateHelper().eval(PropertyKeys.placement);
    if (placement != null) {
      return placement;
    }
    return org.apache.myfaces.tobago.layout.Placement.bottomRight;
  }

  public void setPlacement(org.apache.myfaces.tobago.layout.Placement placement) {
    getStateHelper().put(PropertyKeys.placement, placement);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}